import * as react from 'react';
import * as _fluidui_org_system from '@fluidui-org/system';
import { PropGetter, HTMLHeroUIProps } from '@fluidui-org/system';
import { ScrollShadowVariantProps } from '@fluidui-org/theme';
import { ReactRef } from '@fluidui-org/react-utils';
import { UseDataScrollOverflowProps } from '@fluidui-org/use-data-scroll-overflow';

interface Props extends HTMLHeroUIProps<"div">, Omit<UseDataScrollOverflowProps, "domRef"> {
    /**
     * Ref to the DOM node.
     */
    ref?: ReactRef<HTMLElement | null>;
    /**
     * The shadow size in pixels.
     * @default 40
     */
    size?: number;
}
type UseScrollShadowProps = Props & ScrollShadowVariantProps;
declare function useScrollShadow(originalProps: UseScrollShadowProps): {
    Component: _fluidui_org_system.As<any>;
    styles: string;
    domRef: react.RefObject<HTMLElement>;
    children: react.ReactNode;
    getBaseProps: PropGetter;
};
type UseScrollShadowReturn = ReturnType<typeof useScrollShadow>;

export { type UseScrollShadowProps, type UseScrollShadowReturn, useScrollShadow };
